!FnSplitDemo.clw
!010714:RonEisner:Clarion C5b
!Demonstrate results of FnSplit call.
!-----------------------------------

  PROGRAM
  MAP
    MODULE('CW_API')
      FnSplit(*CSTRING Path, *CSTRING Drv, *CSTRING Dir, *CSTRING Nme, *CSTRING Ext),SIGNED,PROC,RAW,NAME('_fnsplit')
    END
  END !MAP

Gbl_eqIniName  EQUATE('.\FnSplitDemo.ini')

                !Gbl_fHistory is used to read/write the selection history queue.
Gbl_fHistory  FILE,DRIVER('ASCII'),CREATE,NAME(Gbl_eqIniName)
                RECORD
sPath             STRING(FILE:MaxFilePath-1)
                END
              END

Gbl_qHistory  QUEUE !Holds selection history for dropdown selection.
sPath           STRING(FILE:MaxFilePath-1)
              END

Gbl_gFNSplit  GROUP !Individual members passed to FnSplit().
csPath          CSTRING(FILE:MaxFilePath)
csDrv           CSTRING(FILE:MaxFilePath)
csDir           CSTRING(FILE:MaxFilePath)
csName          CSTRING(FILE:MaxFileName)
csExt           CSTRING(FILE:MaxFileName)
              END

Gbl_ilNdx     LONG  !Loop index.

Window WINDOW('FnSplitDemo'),AT(,,300,143),CENTER,IMM,SYSTEM,GRAY,DOUBLE
       GROUP('FnSplit Results:'),AT(8,4,284,85),USE(?gFnSplitResults),BOXED
         PROMPT('csDrv:'),AT(23,20),USE(?pcsDrv)
         ENTRY(@s255),AT(47,20,238,10),USE(Gbl_gFNSplit.csDrv),FONT(,,COLOR:INACTIVECAPTIONTEXT,,CHARSET:ANSI), |
             COLOR(COLOR:INACTIVECAPTION),READONLY
         PROMPT('csDir:'),AT(23,36),USE(?pcsDir)
         ENTRY(@s255),AT(47,36,238,10),USE(Gbl_gFNSplit.csDir),FONT(,,COLOR:INACTIVECAPTIONTEXT,,CHARSET:ANSI), |
             COLOR(COLOR:INACTIVECAPTION),READONLY
         PROMPT('csName:'),AT(15,52),USE(?pcsName)
         ENTRY(@s255),AT(47,52,238,10),USE(Gbl_gFNSplit.csName),FONT(,,COLOR:INACTIVECAPTIONTEXT,,CHARSET:ANSI), |
             COLOR(COLOR:INACTIVECAPTION),READONLY
         PROMPT('csExt:'),AT(23,68),USE(?pcsExt)
         ENTRY(@s255),AT(47,68,238,10),USE(Gbl_gFNSplit.csExt),FONT(,,COLOR:INACTIVECAPTIONTEXT,,CHARSET:ANSI), |
             COLOR(COLOR:INACTIVECAPTION),READONLY
       END
       PROMPT('Type or [Select] Filename To Test, Then Press [Call] Button:'),AT(8,96),USE(?pEnter)
       COMBO(@s255),AT(8,108,237,10),USE(Gbl_gFNSplit.csPath),HVSCROLL,DROP(10),FROM(Gbl_qHistory)
       BUTTON('&Select'),AT(248,104,45,14),USE(?bSelect),LEFT,ICON(ICON:Pick)
       BUTTON('&Call FnSplit'),AT(120,124,60,14),USE(?bFnSplit),LEFT,ICON(ICON:Tick),DEFAULT
       BUTTON('E&xit'),AT(248,124,45,14),USE(?bExit),LEFT,ICON(ICON:Cross)
     END

  CODE

  DO rInit
  DO rAccept
  DO rKill

!================================================
rAccept ROUTINE
  OPEN(Window)
  SELECT(?Gbl_gFNSplit:csPath)
  ACCEPT
    CASE EVENT()
    OF Event:Accepted
      CASE FIELD()
      OF ?bExit
        BREAK
      OF ?bFnSplit
        DO rFnSplit
      OF ?bSelect
        DO rSelect
      END !CASE FIELD()
    END !CASE EVENT()
  END !ACCEPT

!================================================
rFnSplit  ROUTINE
  FNSplit( |
          Gbl_gFNSplit.cspath |
         ,Gbl_gFNSplit.csDrv  |
         ,Gbl_gFNSplit.csDir  |
         ,Gbl_gFNSplit.csName |
         ,Gbl_gFNSplit.csExt  |
         )
  DISPLAY()

    !Combobox history handling:
    !-------------------------
  IF Gbl_gFNSplit.cspath !If non-blank path, add or move selection to top of history list:
    Gbl_qHistory.sPath = Gbl_gFNSplit.cspath
    GET(Gbl_qHistory,Gbl_qHistory.sPath)
    IF NOT ERRORCODE() !Get queue record.
      DELETE(Gbl_qHistory)
    END !IF NOT ERRORCODE() !Get queue record.
    ADD(Gbl_qHistory,1) !Force to first queue record (top position in list).
  END !IF Gbl_gFNSplit.cspath

  ?Gbl_gFNSplit:csPath{Prop:Selected} = 1

!================================================
rInit ROUTINE
    !Get path history from ini file:
    !------------------------------
  OPEN(Gbl_fHistory)
  IF NOT ERRORCODE() !Open file.
    SET(Gbl_fHistory)
    LOOP !Get file records.
      YIELD()
      NEXT(Gbl_fHistory)
      IF ERRORCODE() THEN BREAK.
      Gbl_qHistory.sPath = CLIP(Gbl_fHistory.sPath)
      ADD(Gbl_qHistory)
    END !LOOP !Get file records.
  END !IF NOT ERRORCODE() !Open file.
  CLOSE(Gbl_fHistory)
    !Assign 1st & 2nd queue records as defaults:
    !------------------------------------------
  GET(Gbl_qHistory,1)
  Gbl_gFNSplit.csPath = Gbl_qHistory.sPath

!================================================
rKill ROUTINE
    !Add path history to ini file:
    !----------------------------
  CREATE(Gbl_fHistory)
  IF NOT ERRORCODE() !Create file.
    OPEN(Gbl_fHistory)
    IF NOT ERRORCODE() !Open file.
      Gbl_ilNdx = 1
      LOOP !until end-of-queue
        YIELD()
        GET(Gbl_qHistory,Gbl_ilNdx)
        IF NOT ERRORCODE() !Get queue entry.
            !Add to file:
          Gbl_fHistory.sPath = Gbl_qHistory.sPath
          ADD(Gbl_fHistory)
          Gbl_ilNdx += 1
          IF ERRORCODE() THEN BREAK. !Add history record.
        ELSE
          BREAK
        END !IF NOT ERRORCODE() !Get queue entry.
      END !LOOP
    END !IF NOT ERRORCODE() !Open file.
  END !IF NOT ERRORCODE() !Create file.
  CLOSE(Gbl_fHistory)

!================================================
rSelect ROUTINE
  FILEDIALOG('Select File',Gbl_gFNSplit.csPath,'All Files|*.*',10110b)
  DISPLAY(?Gbl_gFNSplit:csPath)

!================================================
![end]
